package com.ucpaas.demo;

import javax.crypto.KeyGenerator;
import javax.crypto.Mac;
import javax.crypto.SecretKey;
import javax.crypto.spec.SecretKeySpec;

import com.ucpaas.demo.decode.Base64;

import net.sf.json.JSONObject;

public class TokenClient {

	public static String formatHearder(String Accid,String Cnumber,String Expiretime){
		JSONObject jsonObject=new JSONObject();
		jsonObject.put("Alg", "HS256");
		jsonObject.put("Accid", Accid);
		jsonObject.put("Cnumber", Cnumber);
		jsonObject.put("Expiretime", Expiretime);
		return jsonObject.toString();
	}
	public static String formatPayload(String Accid,String AccToken,String Cnumber,String Cpwd,String Expiretime){
		JSONObject jsonObject=new JSONObject();
		jsonObject.put("Accid", Accid);
		jsonObject.put("AccToken", AccToken);
		jsonObject.put("Cnumber", Cnumber);
		jsonObject.put("Cpwd", Cpwd);
		jsonObject.put("Expiretime", Expiretime);
		return jsonObject.toString();
	}
	public static byte[] encryptHMAC(byte [] data,String key) throws  Exception {
		SecretKey secretKey=new SecretKeySpec(key.getBytes(), "HmacSHA256");
		Mac mac = Mac.getInstance(secretKey.getAlgorithm());
		mac.init(secretKey);
		return mac.doFinal(data);
	}
	public static String getToken(String Accid,String AccToken,String Cnumber,String Cpwd,String Expiretime){
		try {
			String slcHread=Base64.encode(formatHearder(Accid, Cnumber, Expiretime).getBytes());
			String payload=formatPayload(Accid, AccToken, Cnumber, Cpwd, Expiretime);
			byte[] sec = encryptHMAC(payload.getBytes(), AccToken);
			String slcDepayload=Base64.encode(sec);
			String result=slcHread+"."+slcDepayload;
			return result;
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		return null;
	}
}
